'use strict';

var promises = require('fs/promises');
var buffer = require('buffer');
var jpegJs = require('jpeg-js');
var pngjs = require('pngjs');
var url = require('url');
var webp = require('@cwasm/webp');

var P=e=>{let t=e.slice(0).sort((r,o)=>r-o);return t.length%2===0?(t[t.length/2]+t[t.length/2+1])/2:t[Math.floor(t.length/2)]},T=(e,t)=>{let r=e,o=t*256*3/2,f=e.length/4;for(let n=0;n<4;n+=1){let i=P(e.slice(n*f,(n+1)*f));for(let u=n*f;u<(n+1)*f;u+=1){let s=e[u];r[u]=+(s>i||Math.abs(s-i)<1&&i>o);}}},F=e=>{let t=[];for(let r=0;r<e.length;r+=4){let o=e.slice(r,r+4);t.push(parseInt(o.join(""),2).toString(16));}return t.join("")},N=(e,t)=>{let r=Math.floor(e.width/t),o=Math.floor(e.height/t),f=[];for(let n=0;n<t;n+=1)for(let i=0;i<t;i+=1){let u=0;for(let s=0;s<o;s+=1)for(let a=0;a<r;a+=1){let c=i*r+a,p=((n*o+s)*e.width+c)*4;e.data[p+3]===0?u+=765:u+=e.data[p]+e.data[p+1]+e.data[p+2];}f.push(u);}return T(f,r*o),F(f)},W=(e,t)=>{let r=[],o,f,n,i,u,s,a,c,B,p,k,y,d,v,h=[],H=e.width%t===0,I=e.height%t===0;if(H&&I)return N(e,t);for(let l=0;l<t;l+=1){h.push([]);for(let m=0;m<t;m+=1)h[l].push(0);}let g=e.width/t,b=e.height/t;for(let l=0;l<e.height;l+=1){I?(s=Math.floor(l/b),u=s,o=1,f=0):(B=(l+1)%b,p=B-Math.floor(B),k=B-p,o=1-p,f=p,k>0||l+1===e.height?(s=Math.floor(l/b),u=s):(u=Math.floor(l/b),s=Math.ceil(l/b)));for(let m=0;m<e.width;m+=1){let w,x=(l*e.width+m)*4;e.data[x+3]===0?w=765:w=e.data[x]+e.data[x+1]+e.data[x+2],H?(c=Math.floor(m/g),a=c,n=1,i=0):(y=(m+1)%g,d=y-Math.floor(y),v=y-d,n=1-d,i=d,v>0||m+1===e.width?(c=Math.floor(m/g),a=c):(a=Math.floor(m/g),c=Math.ceil(m/g))),h[u][a]+=w*o*n,h[u][c]+=w*o*i,h[s][a]+=w*f*n,h[s][c]+=w*f*i;}}for(let l=0;l<t;l+=1)for(let m=0;m<t;m+=1)r.push(h[l][m]);return T(r,g*b),F(r)},M=(e,t,r)=>{if(r===1)return N(e,t);if(r===2)return W(e,t);throw new Error("Bad hashing method")};var D=(e,t,r)=>{let o=pngjs.PNG.sync.read(e);return M(o,t,r?2:1)},E=(e,t,r)=>{let o=jpegJs.decode(e);return M(o,t,r?2:1)},z=(e,t,r)=>{let o=webp.decode(e);return M(o,t,r?2:1)},G=e=>{let t=e;return buffer.Buffer.isBuffer(t.data)||buffer.Buffer.isBuffer(t.data)&&t.ext&&t.ext.length>0},S=async(e,t)=>{let{fileTypeFromBuffer:r,fileTypeFromFile:o}=await import('file-type');return typeof e!="string"&&G(e)&&e.ext?{mime:e.ext}:buffer.Buffer.isBuffer(t)?r(t):typeof e=="string"?o(e):""},O=async(e,t,r,o,f)=>{let n=await S(e,f);if(!n)throw new Error("Mime type not found");if(o&&o.lastIndexOf(".")>0){let i=o.split(".").pop().toLowerCase();if(i==="png"&&n.mime==="image/png")return D(f,t,r);if((i==="jpg"||i==="jpeg")&&n.mime==="image/jpeg")return E(f,t,r);if(i==="webp"&&n.mime==="image/webp")return z(f,t,r);throw new Error(`Unrecognized file extension, mime type or mismatch, ext: ${i} / mime: ${n.mime}`)}else {if(process.env.verbose&&console.warn("No file extension found, attempting mime typing."),n.mime==="image/png")return D(f,t,r);if(n.mime==="image/jpeg")return E(f,t,r);if(n.mime==="image/webp")return z(f,t,r);throw new Error(`Unrecognized mime type: ${n.mime}`)}},A=async(e,t,r)=>{if(e===void 0)throw new Error("No image source provided");if(typeof e=="string"&&(e.indexOf("http")===0||e.indexOf("https")===0)){let f=new url.URL(e),n=await fetch(f.href);return O(e,t,r,f.pathname,buffer.Buffer.from(await n.arrayBuffer()))}if(typeof e!="string"&&G(e))return O(e,t,r,e.name,e.data);let o=await promises.readFile(e);return O(e,t,r,e,o)};

exports.imageHash = A;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map